//-------------------------------------------------------------------//
//                                                                   //
//  JFC Copyright (C) Glenn Rosenthal, 1999,2000,2001.               //
//  All rights reserved.                                             //
//                                                                   //   
//  The code do do conversion between ECU, JIS, and Shift-JIS        //
//  was taken from jconv.c which is copyright by Ken R. Lunde,       //
//  Adobe Systems Incorporated.  Full copyright notice is cpp file.  //
//                                                                   //
//-------------------------------------------------------------------//

//-------------------------------------------------------------------
//
//  This module implements the translatin between JWP's internal coding
//  and various other formats.  These formats include various JIS formats,
//  Shift-JIS, EUC, UNICODE, and ASCII.  (ASCII format is only supported
//  as an import format.)
//
//  This module only contains a few routines from the jwp_jisc rotuine.  
//  These are placed in the same file name to make the organization easier.
//
#ifndef jfc_jisc_h
#define jfc_jisc_h

                                    // UTF-8 Flags and values
#define UTF8_VALUE1     0x00        // Value for set bits for single byte UTF-8 Code.
#define UTF8_MASK1      0x80        // Mask (i.e. bits not set by the standard) 0xxxxxxx
#define UTF8_WRITE1     0xff80      // Mask of bits we cannot allow if we are going to write one byte code
#define UTF8_VALUE2     0xc0        // Two byte codes
#define UTF8_MASK2      0xe0        // 110xxxxx 10yyyyyy
#define UTF8_WRITE2     0xf800      // Mask of mits we cannot allow if we are going to write two byte code
#define UTF8_VALUE3     0xe0        // Three byte codes    
#define UTF8_MASK3      0xf0        // 1110xxxx 10yyyyyy 10zzzzzz
#define UTF8_VALUE4     0xf0        // Four byte values
#define UTF8_MASK4      0xf8        // 11110xxx ----    (These values are not supported by JWPce).    

//-------------------------------------------------------------------
//
//  Exported routines.
//
extern int is_utf8     (byte *buffer,int size); // Is a buffer valid UTF-8?
extern int jis2sjis    (int);                   // Convert JIS to shift-JIS.
extern int jis2unicode (int);                   // Convert JIS code into Unicode.
extern int unicode2jis (int);                   // Convert Unicode to JIS code.   

extern void initialize_cp  (void);  // Initialize the conversion routines (adjust for code page)

#endif jfc_jisc_h
